/* Generated by wayland-scanner 1.23.0 */

/*
 * Copyright © 2018 NXP
 * Copyright © 2019 Status Research & Development GmbH.
 * Copyright © 2021 Xaver Hugl
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include <stdbool.h>
#include <stdlib.h>
#include <stdint.h>
#include "wayland-util.h"

extern const struct wl_interface wp_drm_lease_connector_v1_interface;
extern const struct wl_interface wp_drm_lease_request_v1_interface;
extern const struct wl_interface wp_drm_lease_v1_interface;

static const struct wl_interface *drm_lease_v1_types[] = {
	NULL,
	&wp_drm_lease_request_v1_interface,
	&wp_drm_lease_connector_v1_interface,
	&wp_drm_lease_connector_v1_interface,
	&wp_drm_lease_v1_interface,
};

static const struct wl_message wp_drm_lease_device_v1_requests[] = {
	{ "create_lease_request", "n", drm_lease_v1_types + 1 },
	{ "release", "", drm_lease_v1_types + 0 },
};

static const struct wl_message wp_drm_lease_device_v1_events[] = {
	{ "drm_fd", "h", drm_lease_v1_types + 0 },
	{ "connector", "n", drm_lease_v1_types + 2 },
	{ "done", "", drm_lease_v1_types + 0 },
	{ "released", "", drm_lease_v1_types + 0 },
};

WL_EXPORT const struct wl_interface wp_drm_lease_device_v1_interface = {
	"wp_drm_lease_device_v1", 1,
	2, wp_drm_lease_device_v1_requests,
	4, wp_drm_lease_device_v1_events,
};

static const struct wl_message wp_drm_lease_connector_v1_requests[] = {
	{ "destroy", "", drm_lease_v1_types + 0 },
};

static const struct wl_message wp_drm_lease_connector_v1_events[] = {
	{ "name", "s", drm_lease_v1_types + 0 },
	{ "description", "s", drm_lease_v1_types + 0 },
	{ "connector_id", "u", drm_lease_v1_types + 0 },
	{ "done", "", drm_lease_v1_types + 0 },
	{ "withdrawn", "", drm_lease_v1_types + 0 },
};

WL_EXPORT const struct wl_interface wp_drm_lease_connector_v1_interface = {
	"wp_drm_lease_connector_v1", 1,
	1, wp_drm_lease_connector_v1_requests,
	5, wp_drm_lease_connector_v1_events,
};

static const struct wl_message wp_drm_lease_request_v1_requests[] = {
	{ "request_connector", "o", drm_lease_v1_types + 3 },
	{ "submit", "n", drm_lease_v1_types + 4 },
};

WL_EXPORT const struct wl_interface wp_drm_lease_request_v1_interface = {
	"wp_drm_lease_request_v1", 1,
	2, wp_drm_lease_request_v1_requests,
	0, NULL,
};

static const struct wl_message wp_drm_lease_v1_requests[] = {
	{ "destroy", "", drm_lease_v1_types + 0 },
};

static const struct wl_message wp_drm_lease_v1_events[] = {
	{ "lease_fd", "h", drm_lease_v1_types + 0 },
	{ "finished", "", drm_lease_v1_types + 0 },
};

WL_EXPORT const struct wl_interface wp_drm_lease_v1_interface = {
	"wp_drm_lease_v1", 1,
	1, wp_drm_lease_v1_requests,
	2, wp_drm_lease_v1_events,
};

